'''
Copyright (C) 2025 1P2D
https://1p2d.com
me@1p2d.com

Created by 1P2D - Felix Pierron

This file is part of the Shading + pie.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, see <https://www.gnu.org
/licenses>.
'''

import bpy
import os

custom_icons = None

def load_custom_icons():
    global custom_icons
    try:
        custom_icons = bpy.utils.previews.new()
        icons_dir = os.path.join(os.path.dirname(__file__), "icons")

        if not os.path.exists(icons_dir):
            print(f"[Shading +] Icons directory not found: {icons_dir}")
            return

        # Matcaps
        custom_icons.load("clown", os.path.join(icons_dir, "clown.png"), 'IMAGE')
        custom_icons.load("normal", os.path.join(icons_dir, "normal.png"), 'IMAGE')
        custom_icons.load("cartoon", os.path.join(icons_dir, "cartoon.png"), 'IMAGE')
        custom_icons.load("diffuse", os.path.join(icons_dir, "diffuse.png"), 'IMAGE')
        custom_icons.load("double_horizon", os.path.join(icons_dir, "double_horizon.png"), 'IMAGE')
        custom_icons.load("fuel_shaded", os.path.join(icons_dir, "fuel_shaded.png"), 'IMAGE')
        custom_icons.load("photo_horizon", os.path.join(icons_dir, "photo_horizon.png"), 'IMAGE')
        custom_icons.load("red_reflections", os.path.join(icons_dir, "red_reflections.png"), 'IMAGE')
        custom_icons.load("redgloss_better", os.path.join(icons_dir, "redgloss_better.png"), 'IMAGE')
        custom_icons.load("redgloss_oldblender", os.path.join(icons_dir, "redgloss_oldblender.png"), 'IMAGE')
        custom_icons.load("shadesky", os.path.join(icons_dir, "shadesky.png"), 'IMAGE')
        custom_icons.load("showroom", os.path.join(icons_dir, "showroom.png"), 'IMAGE')
        custom_icons.load("vis1", os.path.join(icons_dir, "vis1.png"), 'IMAGE')

        #HDRIs
        custom_icons.load("hdri_sunset", os.path.join(icons_dir, "hdri_sunset.png"), 'IMAGE')
        custom_icons.load("hdri_sunrise", os.path.join(icons_dir, "hdri_sunrise.png"), 'IMAGE')
        custom_icons.load("hdri_studio", os.path.join(icons_dir, "hdri_studio.png"), 'IMAGE')
        custom_icons.load("hdri_night", os.path.join(icons_dir, "hdri_night.png"), 'IMAGE')
        custom_icons.load("hdri_interior", os.path.join(icons_dir, "hdri_interior.png"), 'IMAGE')
        custom_icons.load("hdri_forest", os.path.join(icons_dir, "hdri_forest.png"), 'IMAGE')
        custom_icons.load("hdri_courtyard", os.path.join(icons_dir, "hdri_courtyard.png"), 'IMAGE')
        custom_icons.load("hdri_city", os.path.join(icons_dir, "hdri_city.png"), 'IMAGE')



    except Exception as e:
        print(f"[Shading +] Error loading custom icons: {e}")

def unload_custom_icons():
    global custom_icons
    if custom_icons:
        bpy.utils.previews.remove(custom_icons)
        custom_icons = None
